diff --git a/drivers/power/pmic/Kconfig b/drivers/power/pmic/Kconfig
index ce0adb18a4..c7739228da 100644
--- a/drivers/power/pmic/Kconfig
+++ b/drivers/power/pmic/Kconfig
@@ -306,6 +306,14 @@ config PMIC_TPS65090
 	only, and you can enable the regulator/charger drivers separately if
 	required.
 
+config PMIC_TPS65217
+	bool "Enable driver for Texas Instruments TPS65217 PMIC"
+	---help---
+	The TPS65217 is a PMIC containing several LDOs, DC to DC convertors,
+	FETs and a battery charger. This driver provides register access
+	only, and you can enable the regulator/charger drivers separately if
+	required.
+
 config PMIC_PALMAS
 	bool "Enable driver for Texas Instruments PALMAS PMIC"
 	---help---
diff --git a/drivers/power/pmic/Makefile b/drivers/power/pmic/Makefile
index 401cde32cf..584d6e0e78 100644
--- a/drivers/power/pmic/Makefile
+++ b/drivers/power/pmic/Makefile
@@ -36,7 +36,7 @@ obj-$(CONFIG_POWER_MUIC_MAX8997) += muic_max8997.o
 obj-$(CONFIG_POWER_PCA9450) += pmic_pca9450.o
 obj-$(CONFIG_POWER_PFUZE100) += pmic_pfuze100.o
 obj-$(CONFIG_POWER_PFUZE3000) += pmic_pfuze3000.o
-obj-$(CONFIG_POWER_TPS65217) += pmic_tps65217.o
+obj-$(CONFIG_PMIC_TPS65217) += pmic_tps65217.o
 obj-$(CONFIG_POWER_TPS65218) += pmic_tps62362.o
 obj-$(CONFIG_POWER_TPS65218) += pmic_tps65218.o
 obj-$(CONFIG_POWER_TPS65910) += pmic_tps65910.o
diff --git a/include/configs/am335x_evm.h b/include/configs/am335x_evm.h
index 9070845b7a..7b02d91e47 100644
--- a/include/configs/am335x_evm.h
+++ b/include/configs/am335x_evm.h
@@ -166,7 +166,7 @@
 #define CONFIG_SYS_NS16550_COM6		0x481aa000	/* UART5 */
 
 /* PMIC support */
-#define CONFIG_POWER_TPS65217
+#define CONFIG_PMIC_TPS65217
 #define CONFIG_POWER_TPS65910
 
 /* SPL */
diff --git a/include/configs/am335x_guardian.h b/include/configs/am335x_guardian.h
index 10a95a10a0..e6e7000529 100644
--- a/include/configs/am335x_guardian.h
+++ b/include/configs/am335x_guardian.h
@@ -95,7 +95,7 @@
 #define CONFIG_SYS_NS16550_COM6		0x481aa000	/* UART5 */
 
 /* PMIC support */
-#define CONFIG_POWER_TPS65217
+#define CONFIG_PMIC_TPS65217
 
 /* Bootcount using the RTC block */
 #define CONFIG_SYS_BOOTCOUNT_LE
diff --git a/include/configs/am335x_shc.h b/include/configs/am335x_shc.h
index 5ed4eb3b3c..5ac46bf42b 100644
--- a/include/configs/am335x_shc.h
+++ b/include/configs/am335x_shc.h
@@ -156,7 +156,7 @@
 #define CONFIG_SYS_NS16550_COM6		0x481aa000	/* UART5 */
 
 /* PMIC support */
-#define CONFIG_POWER_TPS65217
+#define CONFIG_PMIC_TPS65217
 
 /* SPL */
 
diff --git a/include/configs/am335x_sl50.h b/include/configs/am335x_sl50.h
index 0da98975ad..e8233c6cca 100644
--- a/include/configs/am335x_sl50.h
+++ b/include/configs/am335x_sl50.h
@@ -50,7 +50,7 @@
 #define CONFIG_SYS_NS16550_COM6		0x481aa000	/* UART5 */
 
 /* PMIC support */
-#define CONFIG_POWER_TPS65217
+#define CONFIG_PMIC_TPS65217
 #define CONFIG_POWER_TPS65910
 
 /* SPL */
diff --git a/include/configs/brppt1.h b/include/configs/brppt1.h
index d5458edbdb..a9d4b84873 100644
--- a/include/configs/brppt1.h
+++ b/include/configs/brppt1.h
@@ -22,7 +22,7 @@
 #define V_OSCK				26000000  /* Clock output from T2 */
 #define V_SCLK				(V_OSCK)
 
-#define CONFIG_POWER_TPS65217
+#define CONFIG_PMIC_TPS65217
 
 /*
  * When we have NAND flash we expect to be making use of mtdparts,
diff --git a/include/configs/bur_am335x_common.h b/include/configs/bur_am335x_common.h
index 9b2e8b5c6e..129356b87f 100644
--- a/include/configs/bur_am335x_common.h
+++ b/include/configs/bur_am335x_common.h
@@ -26,7 +26,7 @@
 /* Timer information */
 #define CONFIG_SYS_PTV			2	/* Divisor: 2^(PTV+1) => 8 */
 #define CONFIG_SYS_TIMERBASE		0x48040000	/* Use Timer2 */
-#define CONFIG_POWER_TPS65217
+#define CONFIG_PMIC_TPS65217
 
 #include <asm/arch/omap.h>
 
diff --git a/include/configs/chiliboard.h b/include/configs/chiliboard.h
index fe49627263..85e8edab23 100644
--- a/include/configs/chiliboard.h
+++ b/include/configs/chiliboard.h
@@ -107,7 +107,7 @@
 #define CONFIG_SYS_NS16550_COM6		0x481aa000	/* UART5 */
 
 /* PMIC support */
-#define CONFIG_POWER_TPS65217
+#define CONFIG_PMIC_TPS65217
 
 /* SPL */
 /* Bootcount using the RTC block */
diff --git a/scripts/config_whitelist.txt b/scripts/config_whitelist.txt
index a6bc234f51..d3695f6720 100644
--- a/scripts/config_whitelist.txt
+++ b/scripts/config_whitelist.txt
@@ -640,6 +640,7 @@ CONFIG_PM
 CONFIG_PMC_BR_PRELIM
 CONFIG_PMC_OR_PRELIM
 CONFIG_PME_PLAT_CLK_DIV
+CONFIG_PMIC_TPS65217
 CONFIG_PMU
 CONFIG_PMW_BASE
 CONFIG_POST
@@ -658,7 +659,6 @@ CONFIG_POWER_PFUZE3000_I2C_ADDR
 CONFIG_POWER_SPI
 CONFIG_POWER_TPS62362
 CONFIG_POWER_TPS65090_EC
-CONFIG_POWER_TPS65217
 CONFIG_POWER_TPS65218
 CONFIG_POWER_TPS65910
 CONFIG_PPC_CLUSTER_START